//
//  CXBackgroundAudio.m
//  Chroniton
//
//  Created by Logan Collins on 4/8/12.
//  Copyright (c) 2012 Sunflower Softworks. All rights reserved.
//

#import "CXBackgroundAudio.h"


@interface CXBackgroundAudio ()

@property (strong, readwrite) AVAsset *asset;
@property (readwrite) CMTime loopTime;

@end


@implementation CXBackgroundAudio

@synthesize asset=_asset;
@synthesize loopTime=_loopTime;

+ (CXBackgroundAudio *)backgroundAudioWithURL:(NSURL *)URL {
	return [self backgroundAudioWithAsset:[AVAsset assetWithURL:URL]];
}

+ (CXBackgroundAudio *)backgroundAudioWithURL:(NSURL *)URL loopTime:(CMTime)loopTime {
	return [self backgroundAudioWithAsset:[AVAsset assetWithURL:URL] loopTime:loopTime];
}

+ (CXBackgroundAudio *)backgroundAudioWithAsset:(AVAsset *)asset {
	return [self backgroundAudioWithAsset:asset loopTime:kCMTimeZero];
}

+ (CXBackgroundAudio *)backgroundAudioWithAsset:(AVAsset *)asset loopTime:(CMTime)loopTime {
	CXBackgroundAudio *backgroundAudio = [[self alloc] init];
	backgroundAudio.asset = asset;
	backgroundAudio.loopTime = loopTime;
	return backgroundAudio;
}

- (NSURL *)URL {
	if ([self.asset respondsToSelector:@selector(URL)]) {
		return [(AVURLAsset *)[self asset] URL];
	}
	return nil;
}

@end
