//
//  CXSound.m
//  Chroniton
//
//  Created by Logan Collins on 4/10/12.
//  Copyright (c) 2012 Sunflower Softworks. All rights reserved.
//

#import "CXSound.h"


@interface CXSound ()

@property (strong, readwrite) AVAsset *asset;

@end


@implementation CXSound

@synthesize asset=_asset;

+ (CXSound *)soundWithURL:(NSURL *)URL {
	return [self soundWithAsset:[AVAsset assetWithURL:URL]];
}

+ (CXSound *)soundWithAsset:(AVAsset *)asset {
	CXSound *sound = [[self alloc] init];
	sound.asset = asset;
	return sound;
}

- (NSURL *)URL {
	if ([self.asset respondsToSelector:@selector(URL)]) {
		return [(AVURLAsset *)[self asset] URL];
	}
	return nil;
}

@end
