//
//  CXDevice.h
//  Chroniton
//
//  Created by Logan Collins on 4/27/12.
//  Copyright (c) 2012 Sunflower Softworks. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <Chroniton/ChronitonDefines.h>


enum {
    CXUserInterfaceIdiomPhone = 0,
    CXUserInterfaceIdiomPad,
    CXUserInterfaceIdiomMac,
};
typedef NSUInteger CXUserInterfaceIdiom;


enum {
    CXDeviceBatteryStateUnknown = 0,
    CXDeviceBatteryStateUnplugged,
    CXDeviceBatteryStateCharging,
    CXDeviceBatteryStateFull,
};
typedef NSUInteger CXDeviceBatteryState;


@interface CXDevice : NSObject

+ (CXDevice *)currentDevice;

@property (readonly) CXUserInterfaceIdiom userInterfaceIdiom;

@property (readonly, getter=isBatteryStateSupported) BOOL batteryStateSupported;
@property (readonly, getter=isBatteryMonitoringEnabled) BOOL batteryMonitoringEnabled;
@property (readonly) CXDeviceBatteryState batteryState;
@property (readonly) float batteryLevel;

@end


CHRONITON_EXTERN NSString * const CXDeviceBatteryLevelDidChangeNotification;
CHRONITON_EXTERN NSString * const CXDeviceBatteryStateDidChangeNotification;
