//
//  CXResponder.h
//  Chroniton
//
//  Created by Logan Collins on 4/22/12.
//  Copyright (c) 2012 Sunflower Softworks. All rights reserved.
//

#import <Foundation/Foundation.h>


@class CXEvent;


@protocol CXResponder <NSObject>

@required

- (id <CXResponder>)nextResponder;

@optional

- (void)keyDown:(CXEvent *)theEvent;
- (void)keyUp:(CXEvent *)theEvent;

- (void)mouseMoved:(CXEvent *)theEvent;

- (void)mouseDown:(CXEvent *)theEvent;
- (void)mouseDragged:(CXEvent *)theEvent;
- (void)mouseUp:(CXEvent *)theEvent;

- (void)rightMouseDown:(CXEvent *)theEvent;
- (void)rightMouseDragged:(CXEvent *)theEvent;
- (void)rightMouseUp:(CXEvent *)theEvent;

- (void)touchesBegan:(NSSet *)touches withEvent:(CXEvent *)theEvent;
- (void)touchesMoved:(NSSet *)touches withEvent:(CXEvent *)theEvent;
- (void)touchesEnded:(NSSet *)touches withEvent:(CXEvent *)theEvent;
- (void)touchesCancelled:(NSSet *)touches withEvent:(CXEvent *)theEvent;

- (void)motionBegan:(CXEvent *)theEvent;
- (void)motionEnded:(CXEvent *)theEvent;
- (void)motionCancelled:(CXEvent *)theEvent;

@end
