//
//  CXTimer.m
//  Chroniton
//
//  Created by Logan Collins on 4/7/12.
//  Copyright (c) 2012 Sunflower Softworks. All rights reserved.
//

#import "CXTimer.h"
#import "CXTimer_Private.h"
#import "CXDirector_Private.h"


@implementation CXTimer

@synthesize director=_director;

@synthesize interval=_interval;
@synthesize repeats=_repeats;
@synthesize block=_block;

@synthesize runLoopTimer=_runLoopTimer;
@synthesize nextInterval=_nextInterval;

+ (CXTimer *)timerWithInterval:(NSTimeInterval)interval repeats:(BOOL)repeats block:(void (^)(void))block {
	CXTimer *timer = [[self alloc] init];
	timer.interval = interval;
	timer.repeats = repeats;
	timer.block = block;
	return timer;
}

- (void)invalidate {
	[self.director invalidateTimer:self];
}

@end
