//
//  CXEvent.m
//  Chroniton
//
//  Created by Logan Collins on 4/16/12.
//  Copyright (c) 2012 Sunflower Softworks. All rights reserved.
//

#import "CXEvent.h"
#import "CXEvent_Private.h"


NSString * CXEventTypeDescription(CXEventType type) {
	NSString *description = nil;
	switch (type) {
		case CXEventTypeTouches: description = @"touches"; break;
		case CXEventTypeMouse: description = @"mouse"; break;
		case CXEventTypeKeyboard: description = @"keyboard"; break;
		case CXEventTypeMotion: description = @"motion"; break;
	}
	return description;
}


NSString * CXEventSubtypeDescription(CXEventType type) {
	NSString *description = nil;
	switch (type) {
		case CXEventSubtypeLeftMouseDown: description = @"left mouse down"; break;
		case CXEventSubtypeLeftMouseDragged: description = @"left mouse dragged"; break;
		case CXEventSubtypeLeftMouseUp: description = @"left mouse up"; break;
		case CXEventSubtypeRightMouseDown: description = @"right mouse down"; break;
		case CXEventSubtypeRightMouseDragged: description = @"right mouse dragged"; break;
		case CXEventSubtypeRightMouseUp: description = @"right mouse up"; break;
		case CXEventSubtypeMouseMoved: description = @"mouse moved"; break;
		case CXEventSubtypeKeyDown: description = @"key down"; break;
		case CXEventSubtypeKeyUp: description = @"key up"; break;
		case CXEventSubtypeMotionShake: description = @"motion shake"; break;
	}
	return description;
}


@implementation CXEvent

@synthesize director=_director;

@synthesize timestamp=_timestamp;
@synthesize type=_type;
@synthesize subtype=_subtype;

@synthesize touches=_touches;

@synthesize location=_location;
@synthesize clickCount=_clickCount;

@synthesize keyCode=_keyCode;
@synthesize repeat=_repeat;

#if TARGET_OS_IPHONE
@synthesize uiEvent=_uiEvent;
#elif TARGET_OS_MAC
@synthesize nsEvent=_nsEvent;
#endif

- (NSString *)description {
	return [NSString stringWithFormat:@"<%@: %p : type: %@, subtype: %@>", [self class], self, CXEventTypeDescription(self.type), CXEventSubtypeDescription(self.subtype)];
}

@end
