//
//  CXGraphics.h
//  Chroniton
//
//  Created by Logan Collins on 4/6/12.
//  Copyright (c) 2012 Sunflower Softworks. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <Chroniton/ChronitonDefines.h>

#if TARGET_OS_IPHONE
#import <CoreGraphics/CoreGraphics.h>
#endif


/*!
 * @function CXGraphicsGetCurrentContext
 * @abstract Gets the current graphics context
 * 
 * @result A CGContextRef object
 */
CHRONITON_EXTERN CGContextRef CXGraphicsGetCurrentContext(void);

/*!
 * @function CXGraphicsPushContext
 * @abstract Pushes a graphics context onto the stack
 * 
 * @param ctx
 * The graphics context to push
 */
CHRONITON_EXTERN void CXGraphicsPushContext(CGContextRef ctx);

/*!
 * @function CXGraphicsPopContext
 * @abstract Pops a graphics context off of the stack
 */
CHRONITON_EXTERN void CXGraphicsPopContext(void);
