//
//  CXGraphics.m
//  Chroniton
//
//  Created by Logan Collins on 4/6/12.
//  Copyright (c) 2012 Sunflower Softworks. All rights reserved.
//

#import "CXGraphics.h"


static CFMutableArrayRef _contextStack = NULL;

CGContextRef CXGraphicsGetCurrentContext(void) {
    CGContextRef ctx = NULL;
    if (_contextStack != nil) {
        CFIndex lastIndex = CFArrayGetCount(_contextStack);
        if (lastIndex >= 0) {
            ctx = (CGContextRef)CFArrayGetValueAtIndex(_contextStack, lastIndex - 1);
        }
    }
    
    return ctx;
}

void CXGraphicsPushContext(CGContextRef ctx) {
    if (_contextStack == NULL) {
        _contextStack = CFArrayCreateMutable(NULL, 0, &kCFTypeArrayCallBacks);
    }
    CFArrayAppendValue(_contextStack, ctx);
}

void CXGraphicsPopContext(void) {
    CFIndex lastIndex = CFArrayGetCount(_contextStack);
    CFArrayRemoveValueAtIndex(_contextStack, lastIndex - 1);
}
