//
//  CXButtonLayer.m
//  Chroniton
//
//  Created by Logan Collins on 4/27/12.
//  Copyright (c) 2012 Sunflower Softworks. All rights reserved.
//

#import "CXButtonLayer.h"
#import "CXImage.h"


@implementation CXButtonLayer {
    NSMutableDictionary *_images;
}

+ (BOOL)needsDisplayForKey:(NSString *)key {
    if ([key isEqualToString:@"state"]) {
        return YES;
    }
    return [super needsDisplayForKey:key];
}

- (id)init {
    self = [super init];
    if (self) {
        _images = [NSMutableDictionary dictionary];
    }
    return self;
}

- (void)display {
    CXImage *image = [_images objectForKey:[NSNumber numberWithInteger:self.state]];
    if (image == nil) {
        image = [_images objectForKey:[NSNumber numberWithInteger:CXControlStateNormal]];
    }
    
    self.contents = (id)image.CGImage;
}


#pragma mark -
#pragma mark Presentation

- (CXImage *)imageForState:(CXControlState)state {
    return [_images objectForKey:[NSNumber numberWithInteger:state]];
}

- (void)setImage:(CXImage *)image forState:(CXControlState)state {
    if (image != nil) {
        [_images setObject:image forKey:[NSNumber numberWithInteger:state]];
    }
    else {
        [_images removeObjectForKey:[NSNumber numberWithInteger:state]];
    }
    [self setNeedsDisplay];
}

@end
