//
//  CXControlLayer.h
//  Chroniton
//
//  Created by Logan Collins on 4/26/12.
//  Copyright (c) 2012 Sunflower Softworks. All rights reserved.
//

#import <Chroniton/CXLayer.h>


enum {
    CXControlEventTouchDown         = (1 << 0),
    CXControlEventTouchDownRepeat   = (1 << 1),
    CXControlEventTouchDragInside   = (1 << 2),
    CXControlEventTouchDragOutside  = (1 << 3),
    CXControlEventTouchDragEnter    = (1 << 4),
    CXControlEventTouchDragExit     = (1 << 5),
    CXControlEventTouchUpInside     = (1 << 6),
    CXControlEventTouchUpOutside    = (1 << 7),
    CXControlEventTouchCancel       = (1 << 8),
    
    CXControlEventValueChanged      = (1 << 12),
    
    CXControlEventAllTouchEvents    = 0x0000FFF,
};
typedef NSUInteger CXControlEvents;


enum {
    CXControlStateNormal        = 0,
    CXControlStateHighlighted   = (1 << 0),
    CXControlStateDisabled      = (1 << 1),
    CXControlStateSelected      = (1 << 2),
};
typedef NSUInteger CXControlState;


@interface CXControlLayer : CXLayer

@property (readonly) CXControlState state;
@property (getter=isEnabled) BOOL enabled;
@property (getter=isSelected) BOOL selected;
@property (getter=isHighlighted) BOOL highlighted;

- (void)addTarget:(id)target action:(SEL)action forControlEvents:(CXControlEvents)controlEvents;
- (void)removeTarget:(id)target action:(SEL)action forControlEvents:(CXControlEvents)controlEvents;
- (NSArray *)actionsForTarget:(id)target forControlEvents:(CXControlEvents)controlEvents;

- (NSArray *)allTargets;
- (CXControlEvents)allControlEvents;

- (void)sendAction:(SEL)action to:(id)target forEvent:(CXEvent *)event;

@end
