//
//  CXLayer.m
//  Chroniton
//
//  Created by Logan Collins on 4/21/12.
//  Copyright (c) 2012 Sunflower Softworks. All rights reserved.
//

#import "CXLayer.h"
#import "CXLayer_Private.h"


@implementation CXLayer

- (void)layoutSublayers {
    if ([self.delegate respondsToSelector:@selector(layoutSublayersOfLayer:)]) {
        [self.delegate layoutSublayersOfLayer:self];
    }
    else {
        [super layoutSublayers];
    }
}

@end


@implementation CALayer (CXLayerAdditions)

- (id <CXResponder>)nextResponder {
    return [self superlayer];
}

- (void)keyDown:(CXEvent *)theEvent {
    if ([[self nextResponder] respondsToSelector:@selector(keyDown:)]) {
        [[self nextResponder] keyDown:theEvent];
    }
}

- (void)keyUp:(CXEvent *)theEvent {
    if ([[self nextResponder] respondsToSelector:@selector(keyUp:)]) {
        [[self nextResponder] keyUp:theEvent];
    }
}

- (void)mouseMoved:(CXEvent *)theEvent {
    if ([[self nextResponder] respondsToSelector:@selector(mouseMoved:)]) {
        [[self nextResponder] mouseMoved:theEvent];
    }
}

- (void)mouseDown:(CXEvent *)theEvent {
    if ([[self nextResponder] respondsToSelector:@selector(mouseDown:)]) {
        [[self nextResponder] mouseDown:theEvent];
    }
}

- (void)mouseDragged:(CXEvent *)theEvent {
    if ([[self nextResponder] respondsToSelector:@selector(mouseDragged:)]) {
        [[self nextResponder] mouseDragged:theEvent];
    }
}

- (void)mouseUp:(CXEvent *)theEvent {
    if ([[self nextResponder] respondsToSelector:@selector(mouseUp:)]) {
        [[self nextResponder] mouseUp:theEvent];
    }
}

- (void)rightMouseDown:(CXEvent *)theEvent {
    if ([[self nextResponder] respondsToSelector:@selector(rightMouseDown:)]) {
        [[self nextResponder] rightMouseDown:theEvent];
    }
}

- (void)rightMouseDragged:(CXEvent *)theEvent {
    if ([[self nextResponder] respondsToSelector:@selector(rightMouseDragged:)]) {
        [[self nextResponder] rightMouseDragged:theEvent];
    }
}

- (void)rightMouseUp:(CXEvent *)theEvent {
    if ([[self nextResponder] respondsToSelector:@selector(rightMouseUp:)]) {
        [[self nextResponder] rightMouseUp:theEvent];
    }
}

- (void)touchesBegan:(NSSet *)touches withEvent:(CXEvent *)theEvent {
    if ([[self nextResponder] respondsToSelector:@selector(touchesBegan:withEvent:)]) {
        [[self nextResponder] touchesBegan:touches withEvent:theEvent];
    }
}

- (void)touchesMoved:(NSSet *)touches withEvent:(CXEvent *)theEvent {
    if ([[self nextResponder] respondsToSelector:@selector(touchesMoved:withEvent:)]) {
        [[self nextResponder] touchesMoved:touches withEvent:theEvent];
    }
}

- (void)touchesEnded:(NSSet *)touches withEvent:(CXEvent *)theEvent {
    if ([[self nextResponder] respondsToSelector:@selector(touchesEnded:withEvent:)]) {
        [[self nextResponder] touchesEnded:touches withEvent:theEvent];
    }
}

- (void)touchesCancelled:(NSSet *)touches withEvent:(CXEvent *)theEvent {
    if ([[self nextResponder] respondsToSelector:@selector(touchesCancelled:withEvent:)]) {
        [[self nextResponder] touchesCancelled:touches withEvent:theEvent];
    }
}

- (void)motionBegan:(CXEvent *)theEvent {
    if ([[self nextResponder] respondsToSelector:@selector(motionBegan:)]) {
        [[self nextResponder] motionBegan:theEvent];
    }
}

- (void)motionEnded:(CXEvent *)theEvent {
    if ([[self nextResponder] respondsToSelector:@selector(motionEnded:)]) {
        [[self nextResponder] motionEnded:theEvent];
    }
}

- (void)motionCancelled:(CXEvent *)theEvent {
    if ([[self nextResponder] respondsToSelector:@selector(motionCancelled:)]) {
        [[self nextResponder] motionCancelled:theEvent];
    }
}

@end
