//
//  CXScene.m
//  Chroniton
//
//  Created by Logan Collins on 4/3/12.
//  Copyright (c) 2012 Sunflower Softworks. All rights reserved.
//

#import "CXScene.h"
#import "CXScene_Private.h"

#import "CXDirector_Private.h"
#import "CXLayer_Private.h"
#import "CXSceneLayer.h"

#import "CXAudioPlayer.h"
#import "CXBackgroundAudio.h"


@implementation CXScene

@synthesize layer=_layer;
@synthesize director=_director;

+ (id)scene {
	return [[self alloc] init];
}

- (id)init {
	return [self initWithLayer:[CXSceneLayer layerWithScene:self]];
}

- (id)initWithLayer:(CXLayer *)layer {
	if (layer == nil) {
		return nil;
	}
	
	self = [super init];
	if (self) {
		self.layer = layer;
		layer.delegate = self;
	}
	return self;
}


#pragma mark -
#pragma mark Responder

- (id <CXResponder>)nextResponder {
    return nil;
}


#pragma mark -
#pragma mark Push/Pop

- (void)sceneWillStart {
	
}

- (void)sceneDidStart {
	
}

- (void)sceneWillPause {
	
}

- (void)sceneDidPause {
	
}

- (void)sceneWillResume {
	
}

- (void)sceneDidResume {
	
}

- (void)sceneWillEnd {
	
}

- (void)sceneDidEnd {
	
}


#pragma mark -
#pragma mark Metrics

- (CGPoint)convertPointFromBase:(CGPoint)basePoint {
    CALayer *baseLayer = [[[self director] baseLayer] superlayer];
    return [[self layer] convertPoint:basePoint fromLayer:baseLayer];
}

- (CGPoint)convertPointToBase:(CGPoint)scenePoint {
    CALayer *baseLayer = [[[self director] baseLayer] superlayer];
    return [[self layer] convertPoint:scenePoint toLayer:baseLayer];
}

- (CGRect)convertRectFromBase:(CGRect)baseRect {
    CALayer *baseLayer = [[[self director] baseLayer] superlayer];
    return [[self layer] convertRect:baseRect fromLayer:baseLayer];
}

- (CGRect)convertRectToBase:(CGRect)sceneRect {
    CALayer *baseLayer = [[[self director] baseLayer] superlayer];
    return [[self layer] convertRect:sceneRect toLayer:baseLayer];
}

@end
