//
//  CXSprite.m
//  Chroniton
//
//  Created by Logan Collins on 4/7/12.
//  Copyright (c) 2012 Sunflower Softworks. All rights reserved.
//

#import "CXSprite.h"
#import "CXImage.h"


@interface CXSprite ()

@property (strong, readwrite) CXImage *image;
@property (readwrite) CGRect frame;

@end


@implementation CXSprite/* {
    CGImageRef _cgImage;
}*/

@synthesize image=_image;
@synthesize frame=_frame;

+ (CXSprite *)spriteWithImage:(CXImage *)image frame:(CGRect)frame {
	//return [[self alloc] initWithImage:image frame:frame];
    CGImageRef cgImage = [image CGImage];
    CGImageRef newImage = CGImageCreateWithImageInRect(cgImage, frame);
    CXSprite *sprite = (CXSprite *)[self imageWithCGImage:newImage];
    CGImageRelease(newImage);
    return sprite;
}

/*- (id)initWithImage:(CXImage *)image frame:(CGRect)frame {
	self = [super init];
	if (self) {
		self.image = image;
		self.frame = frame;
	}
	return self;
}

- (void)dealloc {
    if (_cgImage != NULL) {
        CFRelease(_cgImage);
    }
}

- (CGImageRef)CGImage {
    if (_cgImage == NULL) {
        _cgImage = CGImageCreateWithImageInRect([self image].CGImage, [self frame]);
    }
    return _cgImage;
}*/

@end


@implementation CXImage (CXSpriteAdditions)

- (CXSprite *)spriteWithFrame:(CGRect)frame {
	return [CXSprite spriteWithImage:self frame:frame];
}

@end
