//
//  CXGameView.h
//  Chroniton
//
//  Created by Logan Collins on 4/16/12.
//  Copyright (c) 2012 Sunflower Softworks. All rights reserved.
//

#import <Foundation/Foundation.h>
#if TARGET_OS_IPHONE
#import <UIKit/UIKit.h>
#elif TARGET_OS_MAC
#import <AppKit/AppKit.h>
#endif


@class CXDirector;


/*!
 * @class CXGameView
 * @abstract View for game rendering
 * 
 * @discussion
 * CXGameView is the central funnel for receing events and user
 * interaction and passing those interactions down to the game engine.
 */
#if TARGET_OS_IPHONE
@interface CXGameView : UIView
#elif TARGET_OS_MAC
@interface CXGameView : NSView
#endif

/*!
 * @property director
 * @abstract The director object receving events
 * 
 * @discussion
 * By default, this value is the shared CXDirector object.
 * You can set a different subclass of CXDirector to customize
 * event behaviors, although this is rarely necessary.
 * 
 * @result A CXDirector object
 */
@property (strong) CXDirector *director;

@end
